-- ================================================================== --
-- SISTEMA         : Comissaria                                       --
-- DATA DA CRIAO : Incio - 31/03/2000                              --
-- PROGRAMADORES   : Leonardo Monteiro                                --
-- OBJETIVOS       : Cancelar Delivery                                --
-- MANUTENO      : 11/07/2001 - LUCIANA CORREA - MULTI-EMPRESA      --
-- @C:\WIN_PRJ\SQL\ORACLE\2703_ATESTP_CancelaDelivery.sql
-- ================================================================== --
CREATE OR REPLACE PROCEDURE CANCELA_DELIVERY(
  P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE, 
  P_CDCIA        IN COMPANHIA.CDCIA%TYPE,
  P_NRVOO        IN VOO.NRVOO%TYPE,
  P_CDTRECHO     IN VOOTRECHO.CDTRECHO%TYPE,
  P_DTHRPLAVOOPV IN PLANOVOO.DTHRPLAVOOPV%TYPE,
  P_VRDESCCOND   IN DESPERCIA.VRUTIDESC%TYPE,
  P_NRDELIVERY   IN DELIVERY.NRDELIVERY%TYPE,
  P_CDOPCANCDELI IN DELIVERY.CDOPCANCDELI%TYPE)
AS

BEGIN
   UPDATE SERVPLANO
   SET NRDELIVERY = NULL,
       IDSITSERSP = '1'
   WHERE (CDFILIAL   = P_CDFILIAL  ) AND
         (NRDELIVERY = P_NRDELIVERY);

   UPDATE DELIVERY
   SET    IDSITDEL = '3',
          CDOPCANCDELI = P_CDOPCANCDELI 
   WHERE (CDFILIAL   = P_CDFILIAL  ) AND
         (NRDELIVERY = P_NRDELIVERY);

   IF P_VRDESCCOND > 0 THEN
     	UPDATE DESPERCIA
     	SET VRUTIDESC = VRUTIDESC - P_VRDESCCOND
     	WHERE (CDFILIAL = P_CDFILIAL) AND
            (CDCIA    = P_CDCIA   ) AND
            (P_DTHRPLAVOOPV BETWEEN DTINIDESC AND DTFIMDESC);
   END IF;

   UPDATE PLANOVOO
   SET    IDSITABASPV = '1'
   WHERE (CDFILIAL     = P_CDFILIAL    ) AND
         (CDCIA        = P_CDCIA       ) AND
         (NRVOO        = P_NRVOO       ) AND
         (CDTRECHO     = P_CDTRECHO    ) AND
         (DTHRPLAVOOPV = P_DTHRPLAVOOPV) AND
         (IDSITABASPV  = '2'           );
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('CANCELA_DELIVERY','4.11.027'); END;
/

